
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity SandboxTemplate is
	Port (

    -- ADC
		adc_00_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_01_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_02_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_03_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_04_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_05_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_06_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_07_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_08_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_09_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_10_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_11_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_12_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_13_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_14_in : in std_logic_vector(15 downto 0) := (others => '0');
		adc_15_in : in std_logic_vector(15 downto 0) := (others => '0');

		-- SBO
		sbo_reg_00_in : in std_logic_vector(15 downto 0) := (others => '0');
		sbo_reg_01_in : in std_logic_vector(15 downto 0) := (others => '0');
		sbo_reg_02_in : in std_logic_vector(15 downto 0) := (others => '0');
		-- you can add more registers here

		-- SBI
    sbi_reg_00_out : out std_logic_vector(15 downto 0);
    sbi_reg_01_out : out std_logic_vector(15 downto 0);
    sbi_reg_02_out : out std_logic_vector(15 downto 0);
    -- you can add more registers here

		-- Timing pulses
		adc_done_pulse_in : in std_logic;
		data_valid_pulse_in : in std_logic;

		-- Sandbox PWM
		sb_pwm_out : out std_logic_vector(31 downto 0);

		-- Main clock running at 250 MHz
		clk_in : in std_logic
	);
end SandboxTemplate;

architecture impl of SandboxTemplate is

	ATTRIBUTE X_INTERFACE_INFO : STRING;
	ATTRIBUTE X_INTERFACE_PARAMETER : STRING;

	ATTRIBUTE X_INTERFACE_INFO of clk_in: SIGNAL is "xilinx.com:signal:clock:1.0 clk CLK";

	-- Informations to infer the SBI interface
	ATTRIBUTE X_INTERFACE_INFO of sbi_reg_00_out: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 SBI reg_00";
	ATTRIBUTE X_INTERFACE_INFO of sbi_reg_01_out: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 SBI reg_01";
	ATTRIBUTE X_INTERFACE_INFO of sbi_reg_02_out: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 SBI reg_02";

	-- Informations to infer the SBO interface
	ATTRIBUTE X_INTERFACE_INFO of sbo_reg_00_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 SBO reg_00";
	ATTRIBUTE X_INTERFACE_INFO of sbo_reg_01_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 SBO reg_01";
	ATTRIBUTE X_INTERFACE_INFO of sbo_reg_02_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 SBO reg_02";

	-- Informations to infer the ADC interface
	ATTRIBUTE X_INTERFACE_INFO of adc_00_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_00";
	ATTRIBUTE X_INTERFACE_INFO of adc_01_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_01";
	ATTRIBUTE X_INTERFACE_INFO of adc_02_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_02";
	ATTRIBUTE X_INTERFACE_INFO of adc_03_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_03";
	ATTRIBUTE X_INTERFACE_INFO of adc_04_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_04";
	ATTRIBUTE X_INTERFACE_INFO of adc_05_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_05";
	ATTRIBUTE X_INTERFACE_INFO of adc_06_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_06";
	ATTRIBUTE X_INTERFACE_INFO of adc_07_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_07";
	ATTRIBUTE X_INTERFACE_INFO of adc_08_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_08";
	ATTRIBUTE X_INTERFACE_INFO of adc_09_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_09";
	ATTRIBUTE X_INTERFACE_INFO of adc_10_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_10";
	ATTRIBUTE X_INTERFACE_INFO of adc_11_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_11";
	ATTRIBUTE X_INTERFACE_INFO of adc_12_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_12";
	ATTRIBUTE X_INTERFACE_INFO of adc_13_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_13";
	ATTRIBUTE X_INTERFACE_INFO of adc_14_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_14";
	ATTRIBUTE X_INTERFACE_INFO of adc_15_in: SIGNAL is "imperix.ch:ix:user_regs_rtl:1.0 ADC reg_15";

begin

	sb_pwm_out <= (others => '0');

	sbi_reg_00_out <= (others => '0');
	sbi_reg_01_out <= (others => '0');
	sbi_reg_02_out <= (others => '0');

	MY_PROCESS : process(clk_in)
	begin
		if rising_edge(clk_in) then

			if adc_done_pulse_in = '1' then
				-- sampled values are available in ADC registers
			end if;

			if data_valid_pulse_in = '1' then
				-- new data have been written to SBO registers
			end if;

		end if;
	end process MY_PROCESS;

end impl;
